zoukankan      html  css  js  c++  java
  • Codeforces Round #379 (Div. 2) C. Anton and Making Potions —— 二分

    题目链接:http://codeforces.com/contest/734/problem/C


    C. Anton and Making Potions
    time limit per test
    4 seconds
    memory limit per test
    256 megabytes
    input
    standard input
    output
    standard output

    Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare npotions.

    Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

    1. Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
    2. Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.

    Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

    Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

    Input

    The first line of the input contains three integers nmk (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

    The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

    The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

    The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.

    There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It's guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

    The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It's guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

    Output

    Print one integer — the minimum time one has to spent in order to prepare n potions.

    Examples
    input
    20 3 2
    10 99
    2 4 3
    20 10 40
    4 15
    10 80
    
    output
    20
    
    input
    20 3 2
    10 99
    2 4 3
    200 100 400
    4 15
    100 800
    
    output
    200
    
    Note

    In the first sample, the optimum answer is to use the second spell of the first type that costs 10 manapoints. Thus, the preparation time of each potion changes to 4 seconds. Also, Anton should use the second spell of the second type to instantly prepare 15 potions spending 80 manapoints. The total number of manapoints used is 10 + 80 = 90, and the preparation time is 4·5 = 20 seconds (15potions were prepared instantly, and the remaining 5 will take 4 seconds each).

    In the second sample, Anton can't use any of the spells, so he just prepares 20 potions, spending 10 seconds on each of them and the answer is 20·10 = 200.



    题解:

    由于魔法2是有序的,所以可以对魔法2进行二分。

    做法:

    1.枚举魔法1, 假设施展完魔法1后,剩下的能量为left, 那么就在能量<=left的情况下,二分出最大效益的魔法2。

    2.由于步骤1是在施展完魔法1后,再施展魔法2的,但有时候只施展魔法2可能会更省时, 所以还需要枚举魔法2.



    代码如下:

     1 #include<bits/stdc++.h>
     2 using namespace std;
     3 typedef long long LL;
     4 const double eps = 1e-6;
     5 const int INF = 2e9;
     6 const LL LNF = 9e18;
     7 const int mod = 1e9+7;
     8 const int maxn = 2e5+10;
     9 
    10 LL a[maxn], b[maxn], c[maxn], d[maxn];
    11 LL n,m,k,x,s;
    12 
    13 void init()
    14 {
    15     cin>>n>>m>>k>>x>>s;
    16     for(int i = 1; i<=m; i++) scanf("%lld",&a[i]);
    17     for(int i = 1; i<=m; i++) scanf("%lld",&b[i]);
    18     for(int i = 1; i<=k; i++) scanf("%lld",&c[i]);
    19     for(int i = 1; i<=k; i++) scanf("%lld",&d[i]);
    20 }
    21 
    22 int Locate(LL e)
    23 {
    24     int l = 1, r = k;
    25     while(l<=r)
    26     {
    27         int mid = (l+r)>>1;
    28         if(d[mid]<=e)
    29             l = mid+1;
    30         else
    31             r = mid-1;
    32     }
    33     return r;    //返回值的范围: 0 ~ k
    34 }
    35 
    36 void solve()
    37 {
    38     LL ans = 1LL*n*x;
    39     for(int i = 1; i<=m; i++)   //枚举魔法1,二分魔法2
    40     {
    41         if(b[i]>s) continue;
    42 
    43         LL left = s - b[i];
    44         int pos = Locate(left);
    45 //          pos = upper_bound(d+1, d+1+k, left) - (d+1);
    46         if(pos<1)
    47             ans = min( ans, 1LL*a[i]*n );
    48         else
    49             ans = min( ans, 1LL*a[i]*(n-c[pos]>0?n-c[pos]:0) );
    50     }
    51 
    52     int pos = Locate(s);    //只是用魔法2
    53 //      pos = upper_bound(d+1, d+1+k, s) - (d+1);
    54     if(pos>=1)
    55          ans = min( ans, 1LL*x*(n-c[pos]>0?n-c[pos]:0) );
    56 
    57     cout<<ans<<endl;
    58 }
    59 
    60 int main()
    61 {
    62     init();
    63     solve();
    64     return 0;
    65 }
    View Code
  • 相关阅读:
    mysql常用技能分享
    php生成器使用总结
    MySQL索引使用方法和性能优化
    servlet相关
    UML图
    How Tomcat Works
    字符串编码
    高效工作
    php 设计模式总结
    python之装饰器
  • 原文地址:https://www.cnblogs.com/DOLFAMINGO/p/7538679.html
Copyright © 2011-2022 走看看